/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public 
 * License version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Initial Developer of the Original Code is R.V.Guha. Portions
 * created by R.V.Guha are copyright (c) 2000 R.V.Guha. All Rights
 * Reserved.
 *
 * Contributors : Jasper van de Gronde (win32 port)
 */

#include <stdlib.h>
#include <string.h>
#ifdef WIN32
#include <ctype.h>
#include <direct.h>
int _chdir( const char *dirname );
#define bzero ZeroMemory
#define snprintf _snprintf
#define strncasecmp strnicmp /* Should this be strncmp or _strnicmp? */
#define sleep Sleep
#endif

#define streq(x, y) (strcmp(x, y) == 0)

/* Jasper van de Gronde
 * Added these to make it easy to redefine them later on.
 * These defines are ONLY meant for network traffic.
 */
#define NETWORK_NEWLINE "\x0A"
#define NETWORK_NEWLINE_LEN 1
#define NETWORK_NEWLINE_CHAR '\x0A'

#ifndef BOOL
typedef int BOOL;
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

char* getMem(size_t size);
void  freeMem(const char* mem);
char* trimLine(char* line);
int nullString(const char* line, int n);
int startsWith(const char* str, const char* prefix);
int startsWith_forgiving_ws(const char* str, const char* prefix);
int endsWith (const char* str, const char* suffix);
#ifdef WIN32
int readn(unsigned int socket, char *ptr, int maxlen);
int readline(unsigned int socket, char *ptr, int maxlen);
int writen(unsigned int socket, char *ptr, int nbytes);
#else
int readn(int fd, char *ptr, int maxlen);
int readline(int fd, char *ptr, int maxlen);
int writen(int fd, char *ptr, int nbytes);
#endif
int numDigits(int n);
char* strduprange(const char* begin, const char* end);
